'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.isNotNull = isNotNull;
exports.isNull = isNull;
exports.isBoolean = isBoolean;
exports.isTrue = isTrue;
exports.isFalse = isFalse;
exports.isNumber = isNumber;
exports.isNotANumber = isNotANumber;
exports.isInfinity = isInfinity;
exports.isString = isString;
exports.isObject = isObject;
exports.isPlainObject = isPlainObject;
exports.isArray = isArray;
exports.isRegExp = isRegExp;
exports.isDate = isDate;
exports.isFunction = isFunction;
exports.isEmail = isEmail;
exports.isUppercase = isUppercase;
exports.isLowercase = isLowercase;
exports.isNotEmpty = isNotEmpty;
exports.isEmpty = isEmpty;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashIsArray = require('lodash/isArray');

var _lodashIsArray2 = _interopRequireDefault(_lodashIsArray);

var _lodashIsBoolean = require('lodash/isBoolean');

var _lodashIsBoolean2 = _interopRequireDefault(_lodashIsBoolean);

var _lodashIsDate = require('lodash/isDate');

var _lodashIsDate2 = _interopRequireDefault(_lodashIsDate);

var _lodashIsEmpty = require('lodash/isEmpty');

var _lodashIsEmpty2 = _interopRequireDefault(_lodashIsEmpty);

var _lodashIsFinite = require('lodash/isFinite');

var _lodashIsFinite2 = _interopRequireDefault(_lodashIsFinite);

var _lodashIsFunction = require('lodash/isFunction');

var _lodashIsFunction2 = _interopRequireDefault(_lodashIsFunction);

var _lodashIsNaN = require('lodash/isNaN');

var _lodashIsNaN2 = _interopRequireDefault(_lodashIsNaN);

var _lodashIsNull = require('lodash/isNull');

var _lodashIsNull2 = _interopRequireDefault(_lodashIsNull);

var _lodashIsNumber = require('lodash/isNumber');

var _lodashIsNumber2 = _interopRequireDefault(_lodashIsNumber);

var _lodashIsObject = require('lodash/isObject');

var _lodashIsObject2 = _interopRequireDefault(_lodashIsObject);

var _lodashIsPlainObject = require('lodash/isPlainObject');

var _lodashIsPlainObject2 = _interopRequireDefault(_lodashIsPlainObject);

var _lodashIsRegExp = require('lodash/isRegExp');

var _lodashIsRegExp2 = _interopRequireDefault(_lodashIsRegExp);

var _lodashIsString = require('lodash/isString');

var _lodashIsString2 = _interopRequireDefault(_lodashIsString);

var _lodashIsTypedArray = require('lodash/isTypedArray');

var _lodashIsTypedArray2 = _interopRequireDefault(_lodashIsTypedArray);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

// Type validators

function isNotNull(value) {
  return !(0, _lodashIsNull2['default'])(value) && !(0, _lodashIsUndefined2['default'])(value);
}

function isNull(value) {
  return (0, _lodashIsNull2['default'])(value) || (0, _lodashIsUndefined2['default'])(value);
}

function isBoolean(value) {
  return (0, _lodashIsBoolean2['default'])(value);
}

function isTrue(value) {
  return value === true;
}

function isFalse(value) {
  return value === false;
}

function isNumber(value) {
  return (0, _lodashIsNumber2['default'])(value) && !(0, _lodashIsNaN2['default'])(value) && (0, _lodashIsFinite2['default'])(value);
}

function isNotANumber(value) {
  return (0, _lodashIsNaN2['default'])(value);
}

function isInfinity(value) {
  return (0, _lodashIsNumber2['default'])(value) && !(0, _lodashIsNaN2['default'])(value) && !(0, _lodashIsFinite2['default'])(value);
}

function isString(value) {
  return (0, _lodashIsString2['default'])(value);
}

function isObject(value) {
  return (0, _lodashIsObject2['default'])(value);
}

function isPlainObject(value) {
  return (0, _lodashIsPlainObject2['default'])(value);
}

function isArray(value) {
  return (0, _lodashIsArray2['default'])(value) || (0, _lodashIsTypedArray2['default'])(value);
}

function isRegExp(value) {
  return (0, _lodashIsRegExp2['default'])(value);
}

function isDate(value) {
  return (0, _lodashIsDate2['default'])(value);
}

function isFunction(value) {
  return (0, _lodashIsFunction2['default'])(value);
}

// String validators

function isEmail(value) {
  return (/^.+@.+$/.test(value)
  );
}

function isUppercase(value) {
  return (0, _lodashIsString2['default'])(value) && value.toUpperCase() === value;
}

function isLowercase(value) {
  return (0, _lodashIsString2['default'])(value) && value.toLowerCase() === value;
}

// Length validators

function isNotEmpty(value) {
  return !(0, _lodashIsEmpty2['default'])(value);
}

function isEmpty(value) {
  return (0, _lodashIsEmpty2['default'])(value);
}